{*****************************************}
{* Main unit for DecadicGrid application *}
{*****************************************}

unit dgrid;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, Menus, ExtCtrls, LCLIntf;

type
  TSums = array[0..9] of Integer;
  TNumbers = array[0..5, 0..9] of Integer;
  TSumLabels = array[0..9] of TStaticText;
  TNumberShapes = array[0..5, 0..9] of TShape;
  TNumberLabels = array[0..5, 0..9] of TStaticText;
  {*********}
  { TfDGrid }
  {*********}
  TfDGrid = class(TForm)
    mMenu: TMainMenu;
    mPuzzle, mPuzzleNew, mPuzzleExit: TMenuItem;
    mOptions, mOptionsSize, mOptionsSize4, mOptionsSize5, mOptionsSize6: TMenuItem;
    mOptionsLevel, mOptionsLevel1, mOptionsLevel2: TMenuItem;
    mHelp, mHelpCopyright, mHelpWebsite, MenuItem1, mHelpAbout: TMenuItem;
    StaticText1: TStaticText;
    shGrid00, shGrid01, shGrid02, shGrid03, shGrid04, shGrid05: TShape;
    shGrid10, shGrid11, shGrid12, shGrid13, shGrid14, shGrid15: TShape;
    shGrid20, shGrid21, shGrid22, shGrid23, shGrid24, shGrid25: TShape;
    shGrid30, shGrid31, shGrid32, shGrid33, shGrid34, shGrid35: TShape;
    shGrid40, shGrid41, shGrid42, shGrid43, shGrid44, shGrid45: TShape;
    shGrid50, shGrid51, shGrid52, shGrid53, shGrid54, shGrid55: TShape;
    shGrid06, shGrid07, shGrid08, shGrid09, shGrid16, shGrid17: TShape;
    shGrid18, shGrid19, shGrid26, shGrid27, shGrid28, shGrid29: TShape;
    shGrid36, shGrid37, shGrid38, shGrid39, shGrid46, shGrid47: TShape;
    shGrid48, shGrid49, shGrid56, shGrid57, shGrid58, shGrid59: TShape;
    laGrid00, laGrid01, laGrid02, laGrid03, laGrid04, laGrid05: TStaticText;
    laGrid10, laGrid11, laGrid12, laGrid13, laGrid14, laGrid15: TStaticText;
    laGrid20, laGrid21, laGrid22, laGrid23, laGrid24, laGrid25: TStaticText;
    laGrid30, laGrid31, laGrid32, laGrid33, laGrid34, laGrid35: TStaticText;
    laGrid40, laGrid41, laGrid42, laGrid43, laGrid44, laGrid45: TStaticText;
    laGrid50, laGrid51, laGrid52, laGrid53, laGrid54, laGrid55: TStaticText;
    laGrid06, laGrid07, laGrid08, laGrid09, laGrid16, laGrid17: TStaticText;
    laGrid18, laGrid19, laGrid26, laGrid27, laGrid28, laGrid29: TStaticText;
    laGrid36, laGrid37, laGrid38, laGrid39, laGrid46, laGrid47: TStaticText;
    laGrid48, laGrid49, laGrid56, laGrid57, laGrid58, laGrid59: TStaticText;
    laSum0, laSum1, laSum2, laSum3, laSum4: TStaticText;
    laSum5, laSum6, laSum7, laSum8, laSum9: TStaticText;
    edHelp, edRules: TMemo;
    btDone, btShow, btClearAll: TButton;
    bt0, bt1, bt2, bt3, bt4, bt5: TButton;
    bt6, bt7, bt8, bt9, btClear: TButton;
    procedure FormCreate(Sender: TObject);
    procedure mPuzzleNewClick(Sender: TObject);
    procedure mPuzzleExitClick(Sender: TObject);
    procedure mOptionsSize4Click(Sender: TObject);
    procedure mOptionsSize5Click(Sender: TObject);
    procedure mOptionsSize6Click(Sender: TObject);
    procedure mOptionsLevel1Click(Sender: TObject);
    procedure mOptionsLevel2Click(Sender: TObject);
    procedure mHelpCopyrightClick(Sender: TObject);
    procedure mHelpWebsiteClick(Sender: TObject);
    procedure mHelpAboutClick(Sender: TObject);
    procedure btDoneClick(Sender: TObject);
    procedure btShowClick(Sender: TObject);
    procedure btClearAllClick(Sender: TObject);
    procedure bt0Click(Sender: TObject);
    procedure bt1Click(Sender: TObject);
    procedure bt2Click(Sender: TObject);
    procedure bt3Click(Sender: TObject);
    procedure bt4Click(Sender: TObject);
    procedure bt5Click(Sender: TObject);
    procedure bt6Click(Sender: TObject);
    procedure bt7Click(Sender: TObject);
    procedure bt8Click(Sender: TObject);
    procedure bt9Click(Sender: TObject);
    procedure btClearClick(Sender: TObject);
    procedure laGrid00Click(Sender: TObject);
    procedure laGrid01Click(Sender: TObject);
    procedure laGrid02Click(Sender: TObject);
    procedure laGrid03Click(Sender: TObject);
    procedure laGrid04Click(Sender: TObject);
    procedure laGrid05Click(Sender: TObject);
    procedure laGrid10Click(Sender: TObject);
    procedure laGrid11Click(Sender: TObject);
    procedure laGrid12Click(Sender: TObject);
    procedure laGrid13Click(Sender: TObject);
    procedure laGrid14Click(Sender: TObject);
    procedure laGrid15Click(Sender: TObject);
    procedure laGrid20Click(Sender: TObject);
    procedure laGrid21Click(Sender: TObject);
    procedure laGrid22Click(Sender: TObject);
    procedure laGrid23Click(Sender: TObject);
    procedure laGrid24Click(Sender: TObject);
    procedure laGrid25Click(Sender: TObject);
    procedure laGrid30Click(Sender: TObject);
    procedure laGrid31Click(Sender: TObject);
    procedure laGrid32Click(Sender: TObject);
    procedure laGrid33Click(Sender: TObject);
    procedure laGrid34Click(Sender: TObject);
    procedure laGrid35Click(Sender: TObject);
    procedure laGrid40Click(Sender: TObject);
    procedure laGrid41Click(Sender: TObject);
    procedure laGrid42Click(Sender: TObject);
    procedure laGrid43Click(Sender: TObject);
    procedure laGrid44Click(Sender: TObject);
    procedure laGrid45Click(Sender: TObject);
    procedure laGrid50Click(Sender: TObject);
    procedure laGrid51Click(Sender: TObject);
    procedure laGrid52Click(Sender: TObject);
    procedure laGrid53Click(Sender: TObject);
    procedure laGrid54Click(Sender: TObject);
    procedure laGrid55Click(Sender: TObject);
    procedure laGrid06Click(Sender: TObject);
    procedure laGrid07Click(Sender: TObject);
    procedure laGrid08Click(Sender: TObject);
    procedure laGrid09Click(Sender: TObject);
    procedure laGrid16Click(Sender: TObject);
    procedure laGrid17Click(Sender: TObject);
    procedure laGrid18Click(Sender: TObject);
    procedure laGrid19Click(Sender: TObject);
    procedure laGrid26Click(Sender: TObject);
    procedure laGrid27Click(Sender: TObject);
    procedure laGrid28Click(Sender: TObject);
    procedure laGrid29Click(Sender: TObject);
    procedure laGrid36Click(Sender: TObject);
    procedure laGrid37Click(Sender: TObject);
    procedure laGrid38Click(Sender: TObject);
    procedure laGrid39Click(Sender: TObject);
    procedure laGrid46Click(Sender: TObject);
    procedure laGrid47Click(Sender: TObject);
    procedure laGrid48Click(Sender: TObject);
    procedure laGrid49Click(Sender: TObject);
    procedure laGrid56Click(Sender: TObject);
    procedure laGrid57Click(Sender: TObject);
    procedure laGrid58Click(Sender: TObject);
    procedure laGrid59Click(Sender: TObject);
  private
    iSizeTemp, iSize, iLevelTemp, iLevel, iRow, iCol: Integer;
    aGridNumbers: TNumbers;
    aGridSums : TSums;
    shGridShapes: TNumberShapes;
    stGridNumbers: TNumberLabels;
    stGridSums: TSumLabels;
  end;

var
  fDGrid: TfDGrid;

implementation

{$R *.lfm}

{ Field selection at given grid position (user click at this filed) }

procedure SelectField(var GridShapes: TNumberShapes; var GridNumbers: TNumberLabels; Row, Col: Integer; var RowSave, ColSave: Integer);

begin
  if GridShapes[Row, Col].Brush.Color <> clYellow then begin                   // can't modify numbers given by the application
    // Number is already selected: unselect it (resetting color)
    if GridShapes[Row, Col].Brush.Color = clRed then begin
      // Unselect the field
      if GridNumbers[Row, Col].Caption = '' then
        GridShapes[Row, Col].Brush.Color := clWhite                            // empty field
      else
        GridShapes[Row, Col].Brush.Color := clLime;                            // field, containing a number
      RowSave := -1; ColSave := -1;                                            // no field actually selected
    end
    // Field is not yet selected: select it (using highlighting color)
    else begin
      // Unselect previously selected field
      if (RowSave <> -1) and (ColSave <> -1) then begin
        if GridNumbers[RowSave, ColSave].Caption = '' then
          GridShapes[RowSave, ColSave].Brush.Color := clWhite                  // empty field
        else
          GridShapes[RowSave, ColSave].Brush.Color := clLime;                  // field, containing a number
      end;
      // Select the field
      GridShapes[Row, Col].Brush.Color := clRed;
      // Remember which field was selected (to place number there, when user pushes a number button)
      RowSave := Row; ColSave := Col;
    end;
  end;
end;

{ Write given number into given grid field (user click on corr. number button) }

procedure WriteNumber(var GridShapes: TNumberShapes; var GridNumbers: TNumberLabels; Number: string; Row, Col: Integer);

begin
  // Do only if there is a field selcted
  if (Row <> -1) and (Col <> -1) then begin
    GridNumbers[Row, Col].Caption := Number;                                   // write the number (or empty string if "Clear" button)
    if Number = '' then
      GridShapes[Row, Col].Brush.Color := clWhite                              // field number was cleared
    else
      GridShapes[Row, Col].Brush.Color := clLime;                              // field number was set
  end;
end;

{*********}
{ TfDGrid }
{*********}

{ Application start: Initialisations }

procedure TfDGrid.FormCreate(Sender: TObject);

begin
  // Create arrays with number shapes and statictexts
  shGridShapes[0, 0] := shGrid00; shGridShapes[0, 1] := shGrid01; shGridShapes[0, 2] := shGrid02; shGridShapes[0, 3] := shGrid03;
  shGridShapes[0, 4] := shGrid04; shGridShapes[0, 5] := shGrid05; shGridShapes[0, 6] := shGrid06; shGridShapes[0, 7] := shGrid07;
  shGridShapes[0, 8] := shGrid08; shGridShapes[0, 9] := shGrid09;
  shGridShapes[1, 0] := shGrid10; shGridShapes[1, 1] := shGrid11; shGridShapes[1, 2] := shGrid12; shGridShapes[1, 3] := shGrid13;
  shGridShapes[1, 4] := shGrid14; shGridShapes[1, 5] := shGrid15; shGridShapes[1, 6] := shGrid16; shGridShapes[1, 7] := shGrid17;
  shGridShapes[1, 8] := shGrid18; shGridShapes[1, 9] := shGrid19;
  shGridShapes[2, 0] := shGrid20; shGridShapes[2, 1] := shGrid21; shGridShapes[2, 2] := shGrid22; shGridShapes[2, 3] := shGrid23;
  shGridShapes[2, 4] := shGrid24; shGridShapes[2, 5] := shGrid25; shGridShapes[2, 6] := shGrid26; shGridShapes[2, 7] := shGrid27;
  shGridShapes[2, 8] := shGrid28; shGridShapes[2, 9] := shGrid29;
  shGridShapes[3, 0] := shGrid30; shGridShapes[3, 1] := shGrid31; shGridShapes[3, 2] := shGrid32; shGridShapes[3, 3] := shGrid33;
  shGridShapes[3, 4] := shGrid34; shGridShapes[3, 5] := shGrid35; shGridShapes[3, 6] := shGrid36; shGridShapes[3, 7] := shGrid37;
  shGridShapes[3, 8] := shGrid38; shGridShapes[3, 9] := shGrid39;
  shGridShapes[4, 0] := shGrid40; shGridShapes[4, 1] := shGrid41; shGridShapes[4, 2] := shGrid42; shGridShapes[4, 3] := shGrid43;
  shGridShapes[4, 4] := shGrid44; shGridShapes[4, 5] := shGrid45; shGridShapes[4, 6] := shGrid46; shGridShapes[4, 7] := shGrid47;
  shGridShapes[4, 8] := shGrid48; shGridShapes[4, 9] := shGrid49;
  shGridShapes[5, 0] := shGrid50; shGridShapes[5, 1] := shGrid51; shGridShapes[5, 2] := shGrid52; shGridShapes[5, 3] := shGrid53;
  shGridShapes[5, 4] := shGrid54; shGridShapes[5, 5] := shGrid55; shGridShapes[5, 6] := shGrid56; shGridShapes[5, 7] := shGrid57;
  shGridShapes[5, 8] := shGrid58; shGridShapes[5, 9] := shGrid59;
  stGridNumbers[0, 0] := laGrid00; stGridNumbers[0, 1] := laGrid01; stGridNumbers[0, 2] := laGrid02; stGridNumbers[0, 3] := laGrid03;
  stGridNumbers[0, 4] := laGrid04; stGridNumbers[0, 5] := laGrid05; stGridNumbers[0, 6] := laGrid06; stGridNumbers[0, 7] := laGrid07;
  stGridNumbers[0, 8] := laGrid08; stGridNumbers[0, 9] := laGrid09;
  stGridNumbers[1, 0] := laGrid10; stGridNumbers[1, 1] := laGrid11; stGridNumbers[1, 2] := laGrid12; stGridNumbers[1, 3] := laGrid13;
  stGridNumbers[1, 4] := laGrid14; stGridNumbers[1, 5] := laGrid15; stGridNumbers[1, 6] := laGrid16; stGridNumbers[1, 7] := laGrid17;
  stGridNumbers[1, 8] := laGrid18; stGridNumbers[1, 9] := laGrid19;
  stGridNumbers[2, 0] := laGrid20; stGridNumbers[2, 1] := laGrid21; stGridNumbers[2, 2] := laGrid22; stGridNumbers[2, 3] := laGrid23;
  stGridNumbers[2, 4] := laGrid24; stGridNumbers[2, 5] := laGrid25; stGridNumbers[2, 6] := laGrid26; stGridNumbers[2, 7] := laGrid27;
  stGridNumbers[2, 8] := laGrid28; stGridNumbers[2, 9] := laGrid29;
  stGridNumbers[3, 0] := laGrid30; stGridNumbers[3, 1] := laGrid31; stGridNumbers[3, 2] := laGrid32; stGridNumbers[3, 3] := laGrid33;
  stGridNumbers[3, 4] := laGrid34; stGridNumbers[3, 5] := laGrid35; stGridNumbers[3, 6] := laGrid36; stGridNumbers[3, 7] := laGrid37;
  stGridNumbers[3, 8] := laGrid38; stGridNumbers[3, 9] := laGrid39;
  stGridNumbers[4, 0] := laGrid40; stGridNumbers[4, 1] := laGrid41; stGridNumbers[4, 2] := laGrid42; stGridNumbers[4, 3] := laGrid43;
  stGridNumbers[4, 4] := laGrid44; stGridNumbers[4, 5] := laGrid45; stGridNumbers[4, 6] := laGrid46; stGridNumbers[4, 7] := laGrid47;
  stGridNumbers[4, 8] := laGrid48; stGridNumbers[4, 9] := laGrid49;
  stGridNumbers[5, 0] := laGrid50; stGridNumbers[5, 1] := laGrid51; stGridNumbers[5, 2] := laGrid52; stGridNumbers[5, 3] := laGrid53;
  stGridNumbers[5, 4] := laGrid54; stGridNumbers[5, 5] := laGrid55; stGridNumbers[5, 6] := laGrid56; stGridNumbers[5, 7] := laGrid57;
  stGridNumbers[5, 8] := laGrid58; stGridNumbers[5, 9] := laGrid59;
  // Create array with column sum statictexts
  stGridSums[0] := laSum0; stGridSums[1] := laSum1; stGridSums[2] := laSum2; stGridSums[3] := laSum3; stGridSums[4] := laSum4;
  stGridSums[5] := laSum5; stGridSums[6] := laSum6; stGridSums[7] := laSum7; stGridSums[8] := laSum8; stGridSums[9] := laSum9;
  // Start random number generator
  Randomize;
  // Application start-up parameters
  iSizeTemp := 5; iLevelTemp := 1;
  iRow := -1; iCol := -1;
  // Generate a new puzzle
  mPuzzleNew.Click;
end;

{ Menu item "Puzzle > New": Generate new puzzle }

procedure TfDGrid.mPuzzleNewClick(Sender: TObject);

var
  Row, Column, N0, N1, N2, N, R, C, I, J: Integer;
  OK: Boolean;

begin
  // Set user option selections active now
  iSize := iSizeTemp; iLevel := iLevelTemp;
  // Hide actually unused fields
  for I := 0 to 5 do begin
    for J := 0 to 9 do begin
      if I > iSize - 1 then begin
        // Actually unused fields
        shGridShapes[I, J].Visible := False; stGridNumbers[I, J].Visible := False;
      end
      else begin
        // Actually used fields
        shGridShapes[I, J].Visible := True; stGridNumbers[I, J].Visible := True;
      end;
    end;
  end;
  // Adapt position of sum labels (nicer display...)
  for I := 0 to 9 do
    stGridSums[I].Top := 592 -(60 * (6 - iSize));                              // 592 = statictext's Top for 6x6 puzzle
  // Generate random numbers at random grid position, according to the game rules
  repeat                                                                       // continue generating numbers, until they are all valid (game rules)
    // Clear the grid array variable
    for I := 0 to iSize - 1 do begin
      for J := 0 to 9 do begin
        aGridNumbers[I, J] := -1;                                              // setting to -1 meaning "not yet containing a number"
      end;
    end;
    // Clear the column sums
    for J := 0 to 9 do
      aGridSums[J] := 0;
    // Generate the numbers
    OK := True;
    for I := 0 to iSize - 1 do begin
      for J := 0 to 9 do begin
        if OK then begin                                                       // this avoids senseless "work" if number isn't valid
          repeat
            Column := Random(10);
          until aGridNumbers[I, Column] = -1;                                  // field has to be empty!
          // Check if number is valid: must not be equal to number in adjacent fields
          for R := -1 to 1 do begin
            for C := -1 to 1 do begin
              if OK then begin                                                 // to avoid sensless "work", as above
                if (I + R >= 0) and (I + R <= iSize - 1) and (Column + C >= 0) and (Column + C <= 9) then begin
                  if aGridNumbers[I + R, Column + C] = J then
                    // If one of the adjacent fields contains the same number, the actual number can't be written to the actual field
                    OK := False;
                end;
              end;
            end;
          end;
          if OK then
            // Write the number to the actual field (in the array variable)
            aGridNumbers[I, Column] := J;
        end;
      end;
    end;
  until OK;                                                                    // regenerate the whole if numbers are not according to game rules
  // "Randomly" select which grid numbers to display
  case iSize of
    // Depending on grid size and level, choose a minimum and maximum of numbers displayed per column
    4: begin N1 := 2; N2 := 2 + (2 - iLevel); end;
    5: begin N1 := 2; N2 := 3 + (2 - iLevel); end;
    6: begin N1 := 2 + (2 - iLevel); N2 := 4 + (2 - iLevel); end;
  end;
  OK := True;
  for J := 0 to 9 do begin
    N0 := Random(N2 - N1 + 1) + N1;                                            // numbers displayed for this column
    for N := 1 to N0 do begin
      // Be sure to really get the number wanted (i.e. be sure all randomly selected rows are different)
      repeat
        Row := Random(iSize);
      until aGridNumbers[Row, J] < 10;                                         // if value > 10, i.e. that field has already been used (cf. next line)
      aGridNumbers[Row, J] += 100;                                             // use the "add 100" to mark the fields with numbers to be displayed
    end;
  end;
  // Fill in the grid numbers
  for I := 0 to iSize - 1 do begin
    for J := 0 to 9 do begin
      if aGridNumbers[I, J] > 10 then begin
        // If the array contains a value > 10, this means that this field's number has to be displayed
        aGridNumbers[I, J] -= 100;                                             // reset number to correct value
        stGridNumbers[I, J].Caption := IntToStr(aGridNumbers[I, J]);           // write number into the grid
        shGridShapes[I, J].Brush.Color := clYellow;                            // mark the fields with numbers given by the program
      end
      else begin
        // These fields will have to be filled in by the user
        stGridNumbers[I, J].Caption := '';
        shGridShapes[I, J].Brush.Color := clWhite;
      end;
    end;
  end;
  // Calculate column sums
  for J := 0 to 9 do begin
    for I := 0 to iSize - 1 do
      aGridSums[J] += aGridNumbers[I, J];
  end;
  // Fill in column sums
  for J := 0 to 9 do
    stGridSums[J].Caption := IntToStr(aGridSums[J]);
  // Adapt button availability
  btDone.Enabled := True; btClearAll.Enabled := True; btShow.Enabled := False;
end;

{ Menu item "Puzzle > Exit": Exit application }

procedure TfDGrid.mPuzzleExitClick(Sender: TObject);

begin
  Close;
end;

{ Menu items "Options > Puzzle size > ...": Select size of the puzzle (4x4, 5x5, 6x6) }

procedure TfDGrid.mOptionsSize4Click(Sender: TObject);

begin
  mOptionsSize4.Checked := True; mOptionsSize5.Checked := False; mOptionsSize6.Checked := False;
  iSizeTemp := 4;                                                              // option will become active when "New puzzle" is selected
end;

procedure TfDGrid.mOptionsSize5Click(Sender: TObject);

begin
  mOptionsSize4.Checked := False; mOptionsSize5.Checked := True; mOptionsSize6.Checked := False;
  iSizeTemp := 5;
end;

procedure TfDGrid.mOptionsSize6Click(Sender: TObject);

begin
  mOptionsSize4.Checked := False; mOptionsSize5.Checked := False; mOptionsSize6.Checked := True;
  iSizeTemp := 6;
end;

{ Menu items "Options > Difficulty > ...": Select game difficulty (level 1 or 2) }

procedure TfDGrid.mOptionsLevel1Click(Sender: TObject);

begin
  mOptionsLevel1.Checked := True; mOptionsLevel2.Checked := False;
  iLevelTemp := 1;                                                             // option will become active when "New puzzle" is selected
end;

procedure TfDGrid.mOptionsLevel2Click(Sender: TObject);

begin
  mOptionsLevel1.Checked := False; mOptionsLevel2.Checked := True;
  iLevelTemp := 2;
end;

procedure TfDGrid.mHelpCopyrightClick(Sender: TObject);

var
  S: string;

begin
  S := 'I found "Decadic Grid" at https://www.janko.at/ (puzzle name: "Zehnergitter"). It may have been invented by Otto Janko ';
  S += 'and by this may underly the Creative Commons 3.0 licence: quotation of the author''s name; no commercial usage; distribution only ';
  S += 'under the same conditions.';
  MessageDlg('DecadicGrid licence', S, mtInformation, [mbOK], 0);
end;

procedure TfDGrid.mHelpWebsiteClick(Sender: TObject);

begin
  OpenDocument('https://www.janko.at/Raetsel/');
end;

{ Menu item "Help > About": Display application about }

procedure TfDGrid.mHelpAboutClick(Sender: TObject);

var
  S: string;

begin
  S := 'Logic game: Decadic Grid.' + LineEnding;
  S += 'Fill the grid with numbers between 0 and 9, accordingly to the Decadic Grid game rules.' + LineEnding + LineEnding;
  S += 'Version 1.0, © allu, July-August 2020.' + LineEnding;
  S += 'See also: Source and copyright.';
  MessageDlg('About "DecadicGrid"', S, mtInformation, [mbOK], 0);
end;

{ Button "Done": Read user solution from form grid values and check if this is a correct solution }

procedure TfDGrid.btDoneClick(Sender: TObject);

// Solution validity check is done by calculating the column sums and comparing these to the displayed values,
// and by checking if there are no adjacent same numbers and not by comparison of the user and generated grid
// numbers; in fact, there might be several correct solutions...

var
  I, J, C, R: Integer;
  Solved: Boolean;
  UserNumbers: TNumbers;
  UserSums: TSums;

begin
  // Disable field number entry (by setting actual field to none)
  iRow := -1; iCol := -1;
  // Get user values from form grid and insert them into an array, similar to the one created, when generating the puzzle
  for I := 0 to iSize - 1 do begin
    for J := 0 to 9 do begin
      if stGridNumbers[I, J].Caption = '' then
        UserNumbers[I, J] := -1
      else
        UserNumbers[I, J] := StrToInt(stGridNumbers[I, J].Caption);
    end;
  end;
  // Calculate column sums of the "user grid"
  for I := 0 to iSize - 1 do begin
    UserSums[I] := 0;
  end;
  for I := 0 to iSize - 1 do begin
    for J := 0 to 9 do begin
      if UserNumbers[I, J] > 0 then begin
        UserSums[J] += UserNumbers[I, J];
      end;
    end;
  end;
  // Compare the "user sums" with the values, that they have to be
  // If one of these value pairs differs, the puzzle has not been solved
  Solved := True;
  for I := 0 to iSize - 1 do begin
    if UserSums[I] <> aGridSums[I] then
      Solved := False;
  end;
  // Check for contiguous same numbers
  if Solved then begin
    for I := 0 to iSize - 1 do begin
      for J := 0 to 9 do begin
        if Solved then begin                                                   // no sense to continue checking, if a false number has been detected
          for R := -1 to 1 do begin
            for C := -1 to 1 do begin
              if (I + R >= 0) and (I + R <= iSize - 1) and (J + C >= 0) and (J + C <= 9) then begin
                if (not (R = 0) and (C = 0)) and (aGridNumbers[I + R, J + C] = aGridNumbers[I, J]) then
                  Solved := False;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  // Display "success or not" message
  if Solved then
    MessageDlg('Decadic Grid', 'You have successfully solved this Decadic Grid puzzle!', mtInformation, [mbOK], 0)
  else begin
    MessageDlg('Decadic Grid', 'Sorry. Your numbers are no valid solution of this Decadic Grid puzzle !', mtInformation, [mbOK], 0);
    btShow.Enabled := True;                                                    // give user possibility to view correct solution
  end;
  // Disable the "Done" and "Clear all" buttons (until "New puzzle" is chosen)
  btDone.Enabled := False; btClearAll.Enabled := False;
end;

{ Button "Show": Show puzzle solution }

procedure TfDGrid.btShowClick(Sender: TObject);

var
  I, J: Integer;

begin
  for I := 0 to iSize -1 do begin
    for J := 0 to 9 do begin
      if shGridShapes[I, J].Brush.Color <> clYellow then begin
        // Do for "not given by application" numbers
        shGridShapes[I, J].Brush.Color := clLime;
        stGridNumbers[I, J].Caption := IntToStr(aGridNumbers[I, J]);
      end;
    end;
  end;
  btShow.Enabled := False;
end;

{ Number buttons: Write corr. number into actually selected grid field }

procedure TfDGrid.bt0Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '0', iRow, iCol);
end;

procedure TfDGrid.bt1Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '1', iRow, iCol);
end;

procedure TfDGrid.bt2Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '2', iRow, iCol);
end;

procedure TfDGrid.bt3Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '3', iRow, iCol);
end;

procedure TfDGrid.bt4Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '4', iRow, iCol);
end;

procedure TfDGrid.bt5Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '5', iRow, iCol);
end;

procedure TfDGrid.bt6Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '6', iRow, iCol);
end;

procedure TfDGrid.bt7Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '7', iRow, iCol);
end;

procedure TfDGrid.bt8Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '8', iRow, iCol);
end;

procedure TfDGrid.bt9Click(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '9', iRow, iCol);
end;

{ Button "Clear": Clear number in actually selected grid field }

procedure TfDGrid.btClearClick(Sender: TObject);

begin
  WriteNumber(shGridShapes, stGridNumbers, '', iRow, iCol);
end;

{ Button "Clear all": Clear all grid fields (if user wants to start over...) }

procedure TfDGrid.btClearAllClick(Sender: TObject);

var
  I, J: Integer;

begin
  for I := 0 to iSize - 1 do begin
    for J := 0 to 9 do begin
      if shGridShapes[I, J].Brush.Color <> clYellow then begin
        shGridShapes[I, J].Brush.Color := clWhite;
        stGridNumbers[I, J].Caption := '';
      end;
    end;
  end;
  iRow := -1; iCol := -1;                                                      // no field actually selected
end;

{ User click on any of the 6x6 statictexts fields: Highlight/unhighlight corresponding shape }

procedure TfDGrid.laGrid00Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 0, iRow, iCol);
end;

procedure TfDGrid.laGrid01Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 1, iRow, iCol);
end;

procedure TfDGrid.laGrid02Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 2, iRow, iCol);
end;

procedure TfDGrid.laGrid03Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 3, iRow, iCol);
end;

procedure TfDGrid.laGrid04Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 4, iRow, iCol);
end;

procedure TfDGrid.laGrid05Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 5, iRow, iCol);
end;

procedure TfDGrid.laGrid06Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 6, iRow, iCol);
end;

procedure TfDGrid.laGrid07Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 7, iRow, iCol);
end;

procedure TfDGrid.laGrid08Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 8, iRow, iCol);
end;

procedure TfDGrid.laGrid09Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 0, 9, iRow, iCol);
end;

procedure TfDGrid.laGrid10Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 0, iRow, iCol);
end;

procedure TfDGrid.laGrid11Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 1, iRow, iCol);
end;

procedure TfDGrid.laGrid12Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 2, iRow, iCol);
end;

procedure TfDGrid.laGrid13Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 3, iRow, iCol);
end;

procedure TfDGrid.laGrid14Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 4, iRow, iCol);
end;

procedure TfDGrid.laGrid15Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 5, iRow, iCol);
end;

procedure TfDGrid.laGrid16Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 6, iRow, iCol);
end;

procedure TfDGrid.laGrid17Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 7, iRow, iCol);
end;

procedure TfDGrid.laGrid18Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 8, iRow, iCol);
end;

procedure TfDGrid.laGrid19Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 1, 9, iRow, iCol);
end;

procedure TfDGrid.laGrid20Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 0, iRow, iCol);
end;

procedure TfDGrid.laGrid21Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 1, iRow, iCol);
end;

procedure TfDGrid.laGrid22Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 2, iRow, iCol);
end;

procedure TfDGrid.laGrid23Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 3, iRow, iCol);
end;

procedure TfDGrid.laGrid24Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 4, iRow, iCol);
end;

procedure TfDGrid.laGrid25Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 5, iRow, iCol);
end;

procedure TfDGrid.laGrid26Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 6, iRow, iCol);
end;

procedure TfDGrid.laGrid27Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 7, iRow, iCol);
end;

procedure TfDGrid.laGrid28Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 8, iRow, iCol);
end;

procedure TfDGrid.laGrid29Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 2, 9, iRow, iCol);
end;

procedure TfDGrid.laGrid30Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 0, iRow, iCol);
end;

procedure TfDGrid.laGrid31Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 1, iRow, iCol);
end;

procedure TfDGrid.laGrid32Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 2, iRow, iCol);
end;

procedure TfDGrid.laGrid33Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 3, iRow, iCol);
end;

procedure TfDGrid.laGrid34Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 4, iRow, iCol);
end;

procedure TfDGrid.laGrid35Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 5, iRow, iCol);
end;

procedure TfDGrid.laGrid36Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 6, iRow, iCol);
end;

procedure TfDGrid.laGrid37Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 7, iRow, iCol);
end;

procedure TfDGrid.laGrid38Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 8, iRow, iCol);
end;

procedure TfDGrid.laGrid39Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 3, 9, iRow, iCol);
end;

procedure TfDGrid.laGrid40Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 0, iRow, iCol);
end;

procedure TfDGrid.laGrid41Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 1, iRow, iCol);
end;

procedure TfDGrid.laGrid42Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 2, iRow, iCol);
end;

procedure TfDGrid.laGrid43Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 3, iRow, iCol);
end;

procedure TfDGrid.laGrid44Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 4, iRow, iCol);
end;

procedure TfDGrid.laGrid45Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 5, iRow, iCol);
end;

procedure TfDGrid.laGrid46Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 6, iRow, iCol);
end;

procedure TfDGrid.laGrid47Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 7, iRow, iCol);
end;

procedure TfDGrid.laGrid48Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 8, iRow, iCol);
end;

procedure TfDGrid.laGrid49Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 4, 9, iRow, iCol);
end;

procedure TfDGrid.laGrid50Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 0, iRow, iCol);
end;

procedure TfDGrid.laGrid51Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 1, iRow, iCol);
end;

procedure TfDGrid.laGrid52Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 2, iRow, iCol);
end;

procedure TfDGrid.laGrid53Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 3, iRow, iCol);
end;

procedure TfDGrid.laGrid54Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 4, iRow, iCol);
end;

procedure TfDGrid.laGrid55Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 5, iRow, iCol);
end;

procedure TfDGrid.laGrid56Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 6, iRow, iCol);
end;

procedure TfDGrid.laGrid57Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 7, iRow, iCol);
end;

procedure TfDGrid.laGrid58Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 8, iRow, iCol);
end;

procedure TfDGrid.laGrid59Click(Sender: TObject);

begin
  SelectField(shGridShapes, stGridNumbers, 5, 9, iRow, iCol);
end;

end.

